/* $Id: dir.h,v 1.8 1997/06/26 19:42:25 gjb Exp $
 * dir.h
 *
 * NFS extern declarations for dir.c
 */

#define NEWCACHE
/* #define DEBUG_NEWCACHE */

#ifdef NEWCACHE
#undef NFS_LOOKUP_CACHE_SIZE
#define NFS_LOOKUP_CACHE_SIZE 512
#define NFS_LOOKUP_CACHE_BUCKETS 127
#define NFSLOOKUPCACHENAMELEN 32
#endif


/* element 0 of this array is not used, except that its next field is
   the start of the free list. */

struct nfs_lookup_cache_entry {
	kdev_t		dev;
	ino_t		inode;
#ifdef NEWCACHE
	char		filename[NFSLOOKUPCACHENAMELEN + 1];
#else
        char            filename[NFS_MAXNAMLEN + 1];
#endif
	struct nfs_fh	fhandle;
	struct nfs_fattr fattr;
	int		expiration_date;
#ifdef NEWCACHE
        int             next;
     int bit;
#endif
};



extern void nfs_lookup_cache_free ( void );
extern void nfs_lookup_cache_allocate ( void );

extern void nfs_lookup_cache_refresh(struct inode *file,
				     struct nfs_fattr *fattr);
extern void nfs_refresh_inode(struct inode *inode, struct nfs_fattr *fattr);

extern void nfs_refresh_inode_cache_name(struct inode *inodeDir,
					 const char *name,struct nfs_fattr *fattr);


extern struct nfs_lookup_cache_entry *
nfs_lookup_cache_index(struct inode *dir, const char *filename
#ifdef NEWCACHE
		       , int *index, int **prevptr
#endif
     );
