/* $Id: profile.h,v 1.27 1997/07/04 20:52:52 gjb Exp $ */

#ifndef _NFS_PROFILE_H_
#define _NFS_PROFILE_H_

#ifndef DAG_NO_INSTRUMENT_NFS
#define nfs_printk(x...)  /* printk( ## x) */
#define wnfs_printk(x...)  /* printk( ## x) */
#define alnfs_printk(x...)  /* printk( ## x) */
#define vnfs_printk(x...)  /* printk( ## x) */
#define verb_wnfs_printk(x...)  /* printk( ## x) */
#define verb_nfs_printk(x...) /* printk( ## x) */ /* verbose debug */
#endif

extern int c_nfs_ops[];

enum nfs_profile_indices { 
  /* super operations (inode.c) */
  i_read_inode = 0,
  i_notify_change,
  i_put_inode,
  i_put_super,
  i_statfs,
  /* dir operations (dir.c) */
  i_readdir,
  i_dir_open,
  /* dir inode operations (dir.c) */
  i_create,
  i_lookup,
  i_link,
  i_unlink,
  i_symlink,
  i_mkdir,
  i_rmdir,
  i_mknod,
  i_rename,
  /* file operations (file.c) */
  i_file_read,
  i_file_write,
  i_file_mmap,
  i_fsync,
  /* file inode operations (file.c) */
  /*  -- same as above, dir inode operations, plus */
  i_readpage,

  /* rpc call tracking */
  /* use: perl -ne 'if (/PROFILE_INC_COUNT\((.*)\)/) { print "  $1,\n"; }' proc.c */
  /* (Then I reordered to make _alloc_fail be the second item --gjb) */
  i_rpc_do_nothing,
  i_rpc_getattr,
  i_rpc_setattr,
  i_rpc_get_root,
  i_rpc_lookup,
  i_rpc_readlink,
  i_rpc_read,
  i_rpc_write_cache,
  i_rpc_write,
  i_rpc_create,
  i_rpc_remove,
  i_rpc_rename,
  i_rpc_link,
  i_rpc_symlink,
  i_rpc_mkdir,
  i_rpc_rmdir,
  i_rpc_readdir,
  i_rpc_statfs,

  /* asynch/sync rpc reading */
  i_readpage_async,
  i_readpage_async_fail,
  i_readpage_async_no_enque,
  i_readpage_sync,
  i_readpage_local,
  i_readpage_total,

  /* writing */
  i_create_write_request,
  i_write_async_fail,
  
  /* lookup cache operations */
  i_lookup_miss,
  i_lookup_cache_index,
  i_lookup_cache_index_expired,
  i_lookup_cache_remove,
  i_lookup_cache_refresh,

  /* failed lookups consume more and more of the lookup
     traffic since they are not cached */
  i_lookup_not_found,

  i_nfs_profile_last_entry /* also a dummy for cvs merges, but used for array size */
};

#define NFS_RPC_INDICES_START i_rpc_do_nothing

#ifndef NO_NFS_PROFILE
#define PROFILE_INC_COUNT(x) do { c_nfs_ops[x]++; } while (0)
#else
#define PROFILE_INC_COUNT(x)
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef BOOL
#define BOOL int
#endif

void nfs_profile_empty_data( void );

#endif /* _NFS_PROFILE_H_ */
