#ifndef _NFS_FS_SB
#define _NFS_FS_SB

#include <linux/nfs.h>
#include <linux/in.h>

/*
 * NFS client parameters
 * Part of this is duplicated in rpc_clnt and is therefore obsolete.
 */
struct nfs_server {
	struct rpc_clnt *	client;		/* RPC client handle */
	int			flags;		/* various flags */
	int			rsize;		/* read size */
	int			wsize;		/* write size */
	unsigned int		bsize;		/* server block size */
	unsigned int		acregmin;	/* attr cache timeouts */
	unsigned int		acregmax;
	unsigned int		acdirmin;
	unsigned int		acdirmax;
	char			hostname[256];	/* remote hostname */
};

#define NFS_MAX_CACHE_ROOT_PATH 256

struct nfs_cache {
	char root[NFS_MAX_CACHE_ROOT_PATH];
	struct inode *inodeDir;
	struct inode *inodeFullStateIndicator;
	int cUpdatesBeforeNextStat;
	int min_free; /* min_free is a property of the local disk cache */
	struct nfs_cache *next;
	int cMountsUsing;
	int bavail; /* from latest stat to check for free space */
};

/*
 * nfs super-block data in memory
 */
struct nfs_sb_info {
	struct nfs_server	s_server;
	struct nfs_fh		s_root;
	struct nfs_cache *s_cache;
	int dc_max_size; /* max size is a property of the nfs mount */
	int dc_pages_used;
};

#endif
